function [large] = pad_reflect_neg(im, xsize, ysize, hor_neg, ver_neg)

% if hor_neg == 0, than reverse the signs when doing horizontal reflection
% Yuanzhen Li (yzli@mit.edu), Jan 2004

if (nargin < 3)
    ysize = xsize;
end

ht = size(im, 1);
wth = size(im, 2);

if hor_neg == 1 & ver_neg == 0
    large = [-im(ysize+1:-1:2, xsize+1:-1:2), im(ysize+1:-1:2, :), ...
        -im(ysize+1:-1:2, wth-1:-1:wth-xsize); ...
        -im(:, xsize+1:-1:2), im, -im(:, wth-1:-1:wth-xsize); ...
        -im(ht-1:-1:ht-ysize, xsize+1:-1:2), ...
        im(ht-1:-1:ht-ysize, :), ...
        -im(ht-1:-1:ht-ysize, wth-1:-1:wth-xsize)];
elseif hor_neg == 0 & ver_neg == 1
    large = [-im(ysize+1:-1:2, xsize+1:-1:2), -im(ysize+1:-1:2, :), ...
        -im(ysize+1:-1:2, wth-1:-1:wth-xsize); ...
        im(:, xsize+1:-1:2), im, im(:, wth-1:-1:wth-xsize); ...
        -im(ht-1:-1:ht-ysize, xsize+1:-1:2), ...
        -im(ht-1:-1:ht-ysize, :), ...
        -im(ht-1:-1:ht-ysize, wth-1:-1:wth-xsize)];
elseif hor_neg == 1 & ver_neg == 1
    large = [im(ysize+1:-1:2, xsize+1:-1:2), -im(ysize+1:-1:2, :), ...
        im(ysize+1:-1:2, wth-1:-1:wth-xsize); ...
        -im(:, xsize+1:-1:2), im, -im(:, wth-1:-1:wth-xsize); ...
        im(ht-1:-1:ht-ysize, xsize+1:-1:2), ...
        -im(ht-1:-1:ht-ysize, :), ...
        im(ht-1:-1:ht-ysize, wth-1:-1:wth-xsize)];
else
    large = [im(ysize+1:-1:2, xsize+1:-1:2), im(ysize+1:-1:2, :), ...
        im(ysize+1:-1:2, wth-1:-1:wth-xsize); ...
        im(:, xsize+1:-1:2), im, im(:, wth-1:-1:wth-xsize); ...
        im(ht-1:-1:ht-ysize, xsize+1:-1:2), ...
        im(ht-1:-1:ht-ysize, :), ...
        im(ht-1:-1:ht-ysize, wth-1:-1:wth-xsize)];
end
